/*******************************************************************************

    Copyright(C) Jonas 'Sortie' Termansen 2011, 2012, 2014.

    This file is part of the Sortix C Library.

    The Sortix C Library is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.

    The Sortix C Library is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with the Sortix C Library. If not, see <http://www.gnu.org/licenses/>.

    stdio/rewind.cpp
    Sets the offset of a FILE to the start and clears any error condition.

*******************************************************************************/

#include <stdio.h>

extern "C" void rewind(FILE* fp)
{
	flockfile(fp);
	fseeko_unlocked(fp, 0, SEEK_SET);
	clearerr_unlocked(fp);
	funlockfile(fp);
}
